Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramDebuggerView.cs	(revision 14777)
@@ -9,7 +9,10 @@
 
   using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.BenchmarkSuite.Views;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Problem;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
   using HeuristicLab.Random;
 
@@ -18,4 +21,5 @@
   public partial class PushProgramDebuggerView : NamedItemView {
     private const string Separator = ", ";
+    private const string EmptySign = "-";
     private PushProgram program;
 
@@ -31,14 +35,26 @@
       Name = "Push Program Debugger";
 
+      InitEvents();
+      InitExecList();
+    }
+
+    private void InitEvents() {
       exampleComboBox.SelectedIndexChanged += SelectedExampleIndexChanged;
       runButton.Click += RunButtonClick;
       resetButton.Click += ResetButtonClick;
       stepButton.Click += StepButtonClick;
-
+      simplifyButton.Click += SimplifyButtonClick;
+    }
+
+    private void SimplifyButtonClick(object sender, EventArgs e) {
+
+    }
+
+    private void InitExecList() {
       execList.RetrieveVirtualItem += ExecListRetrieveVirtualItem;
       execList.CacheVirtualItems += ExecListCacheVirtualItems;
 
       execList.View = View.Details;
-      execList.HeaderStyle = ColumnHeaderStyle.Nonclickable;
+      execList.HeaderStyle = ColumnHeaderStyle.None;
       execList.AutoResizeColumns(ColumnHeaderAutoResizeStyle.None);
       execList.Columns.Add(new ColumnHeader { Width = execList.Width - 40 });
@@ -111,16 +127,20 @@
 
     private void SetReadonlyFields() {
-      exampleComboBox.Enabled = !ReadOnly;
-      execList.Enabled = !ReadOnly;
-      codeList.Enabled = !ReadOnly;
-      nameList.Enabled = !ReadOnly;
-      integerList.Enabled = !ReadOnly;
-      floatList.Enabled = !ReadOnly;
-      booleanList.Enabled = !ReadOnly;
-      stepButton.Enabled = !ReadOnly;
-      runButton.Enabled = !ReadOnly;
-      resetButton.Enabled = !ReadOnly;
-      skipNoopsCheckBox.Enabled = !ReadOnly;
-      stepWidthBox.Enabled = !ReadOnly;
+      var enabled = !ReadOnly;
+
+      exampleComboBox.Enabled = enabled;
+      execList.Enabled = enabled;
+      codeList.Enabled = enabled;
+      nameList.Enabled = enabled;
+      integerList.Enabled = enabled;
+      floatList.Enabled = enabled;
+      booleanList.Enabled = enabled;
+      stringList.Enabled = enabled;
+      charList.Enabled = enabled;
+      stepButton.Enabled = enabled;
+      runButton.Enabled = enabled;
+      resetButton.Enabled = enabled;
+      skipNoopsCheckBox.Enabled = enabled;
+      stepWidthBox.Enabled = enabled;
     }
 
@@ -200,5 +220,5 @@
       interpreter.Clear();
 
-      var example = Content.DataDescriptor.Examples[this.exampleComboBox.SelectedIndex];
+      var example = Content.Data.Examples[this.exampleComboBox.SelectedIndex];
 
       interpreter.BooleanStack.Push(example.InputBoolean);
@@ -217,9 +237,12 @@
       if (Content == null) return;
 
+      this.nameTextBox.Text = "Push Solution";
+
       var random = Content.Random ?? new FastRandom();
       interpreter = new PushInterpreter(Content.Config, random);
       program = Content.IntegerVector.MapToPushProgram(Content.Config.EnabledExpressions);
 
-      UpdateExamples(Content.DataDescriptor);
+      UpdateExamples(Content.Data);
+      InitResultGrid();
 
       if (this.exampleComboBox.SelectedIndex < 0) {
@@ -228,4 +251,102 @@
         Reset();
       }
+    }
+
+    private void InitResultGrid() {
+      var cellTemplate = new DataGridViewTextBoxCell();
+
+      for (var i = 0; i < Content.Data.InputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(Content.Data.InputArgumentTypes[i]);
+        var column = new DataGridViewColumn {
+          HeaderText = string.Format("Input {0} : {1}", i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate
+        };
+
+        resultsDataGrid.Columns.Add(column);
+      }
+
+      for (var i = 0; i < Content.Data.OutputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(Content.Data.OutputArgumentTypes[i]);
+
+        var estimatedOutputColumn = new DataGridViewColumn {
+          HeaderText = string.Format("Estimated Output {0} : {1}", i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate
+        };
+
+        var outputColumn = new DataGridViewColumn {
+          HeaderText = string.Format("Output {0} : {1}", i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate
+        };
+
+        resultsDataGrid.Columns.Add(estimatedOutputColumn);
+        resultsDataGrid.Columns.Add(outputColumn);
+      }
+
+      resultsDataGrid.Columns.Add(
+        new DataGridViewColumn {
+          HeaderText = "Absolute Diff.",
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
+          CellTemplate = cellTemplate
+        });
+
+      resultsDataGrid.Columns.Add(
+        new DataGridViewColumn {
+          HeaderText = "Relative Diff.",
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
+          CellTemplate = cellTemplate,
+        });
+
+      var pool = new PushInterpreterPool(Content.Config);
+      var program = Content.IntegerVector.MapToPushProgram(Content.Config.EnabledExpressions);
+
+      using (var pushInterpreter = pool.Create(Content.Random)) {
+        foreach (var example in Content.Data.Examples) {
+          var row = new DataGridViewRow();
+          var absoluteDiff = PushEvaluator.Evaluate(pushInterpreter, program, example, Content.Data.WorstResult);
+          var relativeDiff = absoluteDiff / Math.Abs(Content.Data.BestResult - Content.Data.WorstResult) * 100d;
+
+          row.HeaderCell.Value = row.Index + 1;
+          row.CreateCells(resultsDataGrid);
+
+          for (var i = 0; i < Content.Data.InputArgumentTypes.Length; i++) {
+            row.Cells[i].Value = ViewHelper.StringifyInput(Content.Data.InputArgumentTypes[i], example, Separator);
+          }
+
+          for (var i = 0; i < Content.Data.OutputArgumentTypes.Length; i++) {
+            row.Cells[Content.Data.InputArgumentTypes.Length + i * 2].Value = ViewHelper.StringifyOutput(Content.Data.OutputArgumentTypes[i], example, Separator);
+            row.Cells[Content.Data.InputArgumentTypes.Length + i * 2 + 1].Value = StringifyResult(Content.Data.OutputArgumentTypes[i], pushInterpreter, example, Separator);
+          }
+
+          row.Cells[Content.Data.TotalArgumentCount + 1].Value = absoluteDiff;
+          row.Cells[Content.Data.TotalArgumentCount + 2].Value = relativeDiff + "%";
+
+          this.resultsDataGrid.Rows.Add(row);
+          pushInterpreter.Clear();
+        }
+      }
+    }
+
+    private string StringifyResult(ExampleArgumentType type, IPushInterpreter interpreter, Example example, string valueSeparator) {
+      switch (type) {
+        case ExampleArgumentType.Integer:
+        case ExampleArgumentType.IntegerCollection: return interpreter.IntegerStack.IsEmpty ? EmptySign : string.Join(valueSeparator, interpreter.IntegerStack.Peek(GetCount(interpreter.IntegerStack, example.OutputInt)));
+
+        case ExampleArgumentType.Float:
+        case ExampleArgumentType.FloatCollection: return interpreter.FloatStack.IsEmpty ? EmptySign : string.Join(valueSeparator, interpreter.FloatStack.Peek(GetCount(interpreter.FloatStack, example.OutputFloat)));
+
+        case ExampleArgumentType.Bool: return interpreter.BooleanStack.IsEmpty ? EmptySign : interpreter.BooleanStack.Top.ToString();
+        case ExampleArgumentType.Char: return interpreter.CharStack.IsEmpty ? EmptySign : interpreter.CharStack.Top.ToString();
+
+        case ExampleArgumentType.String:
+        case ExampleArgumentType.StringCollection: return interpreter.StringStack.IsEmpty ? EmptySign : string.Join(valueSeparator, interpreter.StringStack.Peek(GetCount(interpreter.StringStack, example.OutputString)));
+        default: return string.Empty;
+      }
+    }
+
+    private int GetCount<T>(IStack<T> stack, T[] data) {
+      return Math.Max(0, Math.Min(data.Length, stack.Count));
     }
 
@@ -251,66 +372,28 @@
         return;
 
-      if (interpreter.Configuration.IsCodeStackEnabled) {
-        this.codeList.Enabled = true;
-
-        foreach (var item in interpreter.CodeStack.Reverse())
-          this.codeList.Items.Add(item);
-
-        this.codeGroupBox.Text = string.Format("Code [{0}]", this.codeList.Items.Count);
+      ManageStackType(interpreter.Configuration.IsCodeStackEnabled, codeList, codeGroupBox, interpreter.CodeStack, "Code");
+      ManageStackType(interpreter.Configuration.IsIntegerStackEnabled, integerList, integerGroupBox, interpreter.IntegerStack, "Integer");
+      ManageStackType(interpreter.Configuration.IsFloatStackEnabled, floatList, floatGroupBox, interpreter.FloatStack, "Float");
+      ManageStackType(interpreter.Configuration.IsBooleanStackEnabled, booleanList, booleanGroupBox, interpreter.BooleanStack, "Boolean");
+      ManageStackType(interpreter.Configuration.IsNameStackEnabled, nameList, nameGroupBox, interpreter.NameStack, "Name");
+      ManageStackType(interpreter.Configuration.IsStringStackEnabled, stringList, stringGroupBox, interpreter.StringStack, "String");
+      ManageStackType(interpreter.Configuration.IsCharStackEnabled, charList, charGroupBox, interpreter.CharStack, "Char");
+    }
+
+    private void ManageStackType<T>(bool enabled, ListBox listbox, GroupBox groupBox, IStack<T> stack, string name) {
+      if (enabled) {
+        listbox.Enabled = true;
+
+        foreach (var item in stack.Reverse())
+          listbox.Items.Add(item);
+
+        groupBox.Text = string.Format("{0} [{1}]", name, listbox.Items.Count);
       } else {
-        this.codeList.Enabled = false;
-        this.codeGroupBox.Text = "Code - Disabled";
-      }
-
-      if (interpreter.Configuration.IsIntegerStackEnabled) {
-        this.integerList.Enabled = true;
-
-        foreach (var item in interpreter.IntegerStack.Reverse())
-          this.integerList.Items.Add(item);
-
-        this.integerGroupBox.Text = string.Format("Integer [{0}]", this.integerList.Items.Count);
-      } else {
-        this.integerList.Enabled = false;
-        this.integerGroupBox.Text = "Integer - Disabled";
-      }
-
-      if (interpreter.Configuration.IsFloatStackEnabled) {
-        this.floatList.Enabled = true;
-
-        foreach (var item in interpreter.FloatStack.Reverse())
-          this.floatList.Items.Add(item);
-
-        this.floatGroupBox.Text = string.Format("Float [{0}]", this.floatList.Items.Count);
-      } else {
-        this.floatList.Enabled = false;
-        this.floatGroupBox.Text = "Float - Disabled";
-      }
-
-      if (interpreter.Configuration.IsBooleanStackEnabled) {
-        this.booleanList.Enabled = true;
-
-        foreach (var item in interpreter.BooleanStack.Reverse())
-          this.booleanList.Items.Add(item);
-
-        this.booleanGroupBox.Text = string.Format("Boolean [{0}]", this.booleanList.Items.Count);
-      } else {
-        this.booleanList.Enabled = false;
-        this.booleanGroupBox.Text = "Boolean - Disabled";
-      }
-
-      if (interpreter.Configuration.IsNameStackEnabled) {
-        this.nameList.Enabled = true;
-
-        foreach (var item in interpreter.NameStack.Reverse())
-          this.nameList.Items.Add(item);
-
-        this.nameGroupBox.Text = string.Format("Name [{0}]", this.nameList.Items.Count);
-      } else {
-        this.nameList.Enabled = false;
-        this.nameGroupBox.Text = "Name - Disabled";
-      }
-    }
-
-    private void UpdateExamples(IBenchmarkSuiteDataDescriptor data) {
+        listbox.Enabled = false;
+        groupBox.Text = string.Format("{0} - DISABLED", name);
+      }
+    }
+
+    private void UpdateExamples(Data data) {
       if (data == null) return;
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14777)
@@ -26,10 +26,10 @@
     }
 
-    [TestMethod]
-    [TestProperty("Time", "Medium")]
-    [TestCategory("ProblemTest")]
-    public void Checksum() {
-      RandomWalk(new Checksum());
-    }
+    //[TestMethod]
+    //[TestProperty("Time", "Medium")]
+    //[TestCategory("ProblemTest")]
+    //public void Checksum() {
+    //  RandomWalk(new Checksum());
+    //}
 
     //[TestMethod]
@@ -152,6 +152,6 @@
         PushProgram program;
 
-        using (var interpreter = pool.GetInstance(random)) {
-          program = CodeGenerator.RandomProgram(interpreter.PushProgramPool, maxProgramSizeLimit, random);
+        using (var interpreter = pool.Create(random)) {
+          program = RecursiveCodeGenerator.RandomProgram(maxProgramSizeLimit, random);
 
           for (var j = 0; j < data.OriginalTrainingCount; j++) {
@@ -193,5 +193,5 @@
       var resultsTest = new double[data.OriginalTestCount];
       Parallel.For(data.OriginalTestCount, data.OriginalTestCount, i => {
-        using (var interpreter = pool.GetInstance()) {
+        using (var interpreter = pool.Create()) {
           var example = data.Examples[i];
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 14777)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ProjectFiles</ProjectView>
+    <ProjectView>ShowAllFiles</ProjectView>
   </PropertyGroup>
 </Project>
Index: branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 14777)
@@ -1,34 +1,15 @@
 ﻿using System;
-using System.Diagnostics;
-using System.Linq;
 using System.Threading.Tasks;
 
 namespace HeuristicLab.Algorithms.PushGP.Cli {
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Generators;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
-  using HeuristicLab.Random;
 
   class Program {
     static void Main(string[] args) {
-      //SimpleTest();
-      //Stepwise().Wait();
-      //PerformanceTestInterpreter();
-      //PerformanceParallelTestInterpreter();
-      //PerformanceTestCodeGenerator();
-      TestRobustness();
-      //TestPool();
-      //TestPoolPerformance();
-      //TestSimplifier();
+      if (args.Length == 0) return;
 
-      Console.WriteLine("\nPress any key to continue...");
-
-      //if (args.Length == 0) return;
-
-      //var code = args[0];
-      //EvaluateStepwise(code).Wait();
+      var code = args[0];
+      EvaluateStepwise(code).Wait();
 
       Console.ReadKey();
@@ -58,185 +39,4 @@
       interpreter.PrintStacks();
     }
-
-    static void SimpleTest() {
-      var interpreter = new PushInterpreter();
-
-      interpreter.Run("5 INTEGER.DUP INTEGER.+");
-
-      interpreter.PrintStacks();
-    }
-
-    static async Task Stepwise() {
-      var interpreter = new PushInterpreter();
-
-      interpreter.RunAsync("( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )", true).Wait();
-
-      while (!interpreter.IsCompleted) {
-        Console.Clear();
-        interpreter.PrintStacks();
-        interpreter.Step();
-
-        var input = Console.ReadKey();
-        if (input.Key == ConsoleKey.Escape) {
-          break;
-        } else if (input.Key == ConsoleKey.Spacebar) {
-          await interpreter.ResumeAsync();
-        }
-      }
-
-      Console.Clear();
-      interpreter.PrintStacks();
-    }
-
-    static void PerformanceTestInterpreter() {
-      var program = PushParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
-
-      var interpreter = new PushInterpreter();
-      var sw = new Stopwatch();
-
-      sw.Start();
-      for (var i = 0; i < 60000000; i++) {
-        interpreter.Run(program);
-        interpreter.Clear();
-      }
-      sw.Stop();
-
-      Console.WriteLine(sw.Elapsed);
-    }
-
-    static void PerformanceParallelTestInterpreter() {
-      var program = PushParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
-
-      var sw = new Stopwatch();
-      var iterations = 100;
-      var amount = 600000;
-      var pool = new PushInterpreterPool(iterations, 1024);
-
-      sw.Start();
-      Parallel.For(0, iterations, i => {
-        using (var interpreter = pool.GetInstance()) {
-
-          for (var j = 0; j < amount; j++) {
-            interpreter.Run(program);
-            interpreter.Clear();
-          }
-        }
-      });
-      sw.Stop();
-
-      Console.WriteLine(sw.Elapsed);
-    }
-
-    static void PerformanceTestCodeGenerator() {
-      var sw = new Stopwatch();
-      var random = new FastRandom(1337);
-
-      sw.Start();
-      var expressions = CodeGenerator.RandomCode(60000000, random).ToList();
-      sw.Stop();
-
-      Console.WriteLine("Generated {0} in {1}", expressions.Count(), sw.Elapsed);
-    }
-
-    static void TestRobustness() {
-      var sw = new Stopwatch();
-      var parallelism = Environment.ProcessorCount;
-      var maxProgramSizeLimit = 1024;
-      var partitionSize = 10000;
-      var execCounters = new int[parallelism];
-
-      var config = new PushConfiguration {
-        EvalPushLimit = 4096,
-        IsCodeStackEnabled = false,
-        //IsExecStackEnable = false,
-        //IsBooleanStackEnabled = false,
-        //IsFloatStackEnabled = false,
-        //IsIntegerStackEnabled = false,
-        IsNameStackEnabled = false,
-      };
-
-      var pool = new PushInterpreterPool(config);
-
-      sw.Start();
-      Parallel.For(0, parallelism, i => {
-        var random = new MersenneTwister(1337);
-        using (var interpreter = pool.GetInstance(random)) {
-          for (var j = 0; j < partitionSize; j++) {
-            var program = CodeGenerator.RandomProgram(interpreter.PushProgramPool, maxProgramSizeLimit, random, config);
-            interpreter.Run(program);
-
-            execCounters[i] += interpreter.ExecCounter;
-            interpreter.Clear();
-          }
-        }
-      });
-      sw.Stop();
-
-      Console.WriteLine("ExecCount: {0}", execCounters.Sum());
-      Console.WriteLine("Duration: {0}", sw.Elapsed);
-    }
-
-    static void TestPool() {
-      var pool = new PushInterpreterPool();
-      var normal = new PushInterpreter();
-      int id;
-
-      using (var interpreter = pool.GetInstance()) {
-        interpreter.Run("( 1 2 INTEGER.+ )");
-
-        id = interpreter.GetHashCode();
-        if (id == normal.GetHashCode()) Console.WriteLine("equal 1");
-      }
-
-      using (var interpreter = pool.GetInstance())
-      using (var interpreter2 = pool.GetInstance()) {
-        interpreter.Run("( 1 2 INTEGER.+ )");
-        if (id == interpreter.GetHashCode()) Console.WriteLine("equal 2");
-        if (id == interpreter2.GetHashCode()) Console.WriteLine("equal 3");
-      }
-    }
-
-    static void TestPoolPerformance() {
-      var sw = new Stopwatch();
-      var iterations = 100000000;
-
-      sw.Start();
-      for (var i = 0; i < iterations; i++) {
-        var interpreter = new PushInterpreter();
-        interpreter.Clear();
-      }
-      sw.Stop();
-
-      Console.WriteLine(sw.Elapsed);
-
-      var pool = new PushInterpreterPool();
-      sw.Restart();
-      for (var i = 0; i < iterations; i++) {
-        using (var interpreter = pool.GetInstance()) {
-          interpreter.Clear();
-        }
-      }
-      sw.Stop();
-
-      Console.WriteLine(sw.Elapsed);
-    }
-
-    //static void TestSimplifier() {
-    //  var interpreter = new PushInterpreter();
-    //  var program = PushParser.Parse("( 5 INTEGER.DUP FLOAT.+ INTEGER.+ )") as PushProgram;
-    //  var simplifier = new RandomSimplifier { Trys = 10 };
-    //  var random = new FastRandom(1337);
-
-    //  var simplerProgram = simplifier.Simplify(
-    //    program,
-    //    random,
-    //    solution => {
-    //      interpreter.Clear();
-    //      interpreter.Run(solution);
-    //      return interpreter.IntegerStack.Top == 10;
-    //    });
-
-    //  Console.WriteLine(simplerProgram);
-    //}
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/PushGp.sln
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/PushGp.sln	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/PushGp.sln	(revision 14777)
@@ -12,5 +12,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ProgramSynthesis", "HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.ProgramSynthesis.csproj", "{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "TestPooling", "TestPooling\TestPooling.csproj", "{B184A849-1403-4F5F-96F8-952C6599A7C0}"
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "FeatureTests", "FeatureTests\FeatureTests.csproj", "{B184A849-1403-4F5F-96F8-952C6599A7C0}"
 EndProject
 Global
Index: branches/PushGP/HeuristicLab.PushGP/PushGp.sln.DotSettings.user
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/PushGp.sln.DotSettings.user	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/PushGp.sln.DotSettings.user	(revision 14777)
@@ -3,3 +3,5 @@
   &lt;Assembly Path="T:\BTSync\projects\svn\hl\trunk\sources\bin\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.dll" /&gt;&#xD;
   &lt;Assembly Path="T:\BTSync\projects\svn\hl\trunk\sources\bin\HeuristicLab.Data-3.3.dll" /&gt;&#xD;
-&lt;/AssemblyExplorer&gt;</s:String></wpf:ResourceDictionary>
+&lt;/AssemblyExplorer&gt;</s:String>
+	<s:Boolean x:Key="/Default/VsIntegrationViewOptions/ShowCharts/@EntryValue">False</s:Boolean>
+	</wpf:ResourceDictionary>
